// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package leads

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewGetLeadsObservableParams creates a new GetLeadsObservableParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetLeadsObservableParams() *GetLeadsObservableParams {
	return &GetLeadsObservableParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetLeadsObservableParamsWithTimeout creates a new GetLeadsObservableParams object
// with the ability to set a timeout on a request.
func NewGetLeadsObservableParamsWithTimeout(timeout time.Duration) *GetLeadsObservableParams {
	return &GetLeadsObservableParams{
		timeout: timeout,
	}
}

// NewGetLeadsObservableParamsWithContext creates a new GetLeadsObservableParams object
// with the ability to set a context for a request.
func NewGetLeadsObservableParamsWithContext(ctx context.Context) *GetLeadsObservableParams {
	return &GetLeadsObservableParams{
		Context: ctx,
	}
}

// NewGetLeadsObservableParamsWithHTTPClient creates a new GetLeadsObservableParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetLeadsObservableParamsWithHTTPClient(client *http.Client) *GetLeadsObservableParams {
	return &GetLeadsObservableParams{
		HTTPClient: client,
	}
}

/* GetLeadsObservableParams contains all the parameters to send to the API endpoint
   for the get leads observable operation.

   Typically these are written to a http.Request.
*/
type GetLeadsObservableParams struct {

	/* Email.

	   Email address used for identity lookup
	*/
	Email *string

	/* LeadID.

	   Taxnexus Lead record ID
	*/
	LeadID *string

	/* Name.

	   The Name of this Object
	*/
	Name *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get leads observable params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetLeadsObservableParams) WithDefaults() *GetLeadsObservableParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get leads observable params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetLeadsObservableParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get leads observable params
func (o *GetLeadsObservableParams) WithTimeout(timeout time.Duration) *GetLeadsObservableParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get leads observable params
func (o *GetLeadsObservableParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get leads observable params
func (o *GetLeadsObservableParams) WithContext(ctx context.Context) *GetLeadsObservableParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get leads observable params
func (o *GetLeadsObservableParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get leads observable params
func (o *GetLeadsObservableParams) WithHTTPClient(client *http.Client) *GetLeadsObservableParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get leads observable params
func (o *GetLeadsObservableParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithEmail adds the email to the get leads observable params
func (o *GetLeadsObservableParams) WithEmail(email *string) *GetLeadsObservableParams {
	o.SetEmail(email)
	return o
}

// SetEmail adds the email to the get leads observable params
func (o *GetLeadsObservableParams) SetEmail(email *string) {
	o.Email = email
}

// WithLeadID adds the leadID to the get leads observable params
func (o *GetLeadsObservableParams) WithLeadID(leadID *string) *GetLeadsObservableParams {
	o.SetLeadID(leadID)
	return o
}

// SetLeadID adds the leadId to the get leads observable params
func (o *GetLeadsObservableParams) SetLeadID(leadID *string) {
	o.LeadID = leadID
}

// WithName adds the name to the get leads observable params
func (o *GetLeadsObservableParams) WithName(name *string) *GetLeadsObservableParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the get leads observable params
func (o *GetLeadsObservableParams) SetName(name *string) {
	o.Name = name
}

// WriteToRequest writes these params to a swagger request
func (o *GetLeadsObservableParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Email != nil {

		// query param email
		var qrEmail string

		if o.Email != nil {
			qrEmail = *o.Email
		}
		qEmail := qrEmail
		if qEmail != "" {

			if err := r.SetQueryParam("email", qEmail); err != nil {
				return err
			}
		}
	}

	if o.LeadID != nil {

		// query param leadId
		var qrLeadID string

		if o.LeadID != nil {
			qrLeadID = *o.LeadID
		}
		qLeadID := qrLeadID
		if qLeadID != "" {

			if err := r.SetQueryParam("leadId", qLeadID); err != nil {
				return err
			}
		}
	}

	if o.Name != nil {

		// query param name
		var qrName string

		if o.Name != nil {
			qrName = *o.Name
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
