// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package ingest

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/devops/devops_models"
)

// GetIngestReader is a Reader for the GetIngest structure.
type GetIngestReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetIngestReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetIngestOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetIngestUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetIngestForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetIngestNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetIngestUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetIngestInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetIngestOK creates a GetIngestOK with default headers values
func NewGetIngestOK() *GetIngestOK {
	return &GetIngestOK{}
}

/* GetIngestOK describes a response with status code 200, with default header values.

Single Ingest record response
*/
type GetIngestOK struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Ingest
}

func (o *GetIngestOK) Error() string {
	return fmt.Sprintf("[GET /ingests/{ingestIdPath}][%d] getIngestOK  %+v", 200, o.Payload)
}
func (o *GetIngestOK) GetPayload() *devops_models.Ingest {
	return o.Payload
}

func (o *GetIngestOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Ingest)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetIngestUnauthorized creates a GetIngestUnauthorized with default headers values
func NewGetIngestUnauthorized() *GetIngestUnauthorized {
	return &GetIngestUnauthorized{}
}

/* GetIngestUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type GetIngestUnauthorized struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Error
}

func (o *GetIngestUnauthorized) Error() string {
	return fmt.Sprintf("[GET /ingests/{ingestIdPath}][%d] getIngestUnauthorized  %+v", 401, o.Payload)
}
func (o *GetIngestUnauthorized) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetIngestUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetIngestForbidden creates a GetIngestForbidden with default headers values
func NewGetIngestForbidden() *GetIngestForbidden {
	return &GetIngestForbidden{}
}

/* GetIngestForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type GetIngestForbidden struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetIngestForbidden) Error() string {
	return fmt.Sprintf("[GET /ingests/{ingestIdPath}][%d] getIngestForbidden  %+v", 403, o.Payload)
}
func (o *GetIngestForbidden) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetIngestForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetIngestNotFound creates a GetIngestNotFound with default headers values
func NewGetIngestNotFound() *GetIngestNotFound {
	return &GetIngestNotFound{}
}

/* GetIngestNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type GetIngestNotFound struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetIngestNotFound) Error() string {
	return fmt.Sprintf("[GET /ingests/{ingestIdPath}][%d] getIngestNotFound  %+v", 404, o.Payload)
}
func (o *GetIngestNotFound) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetIngestNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetIngestUnprocessableEntity creates a GetIngestUnprocessableEntity with default headers values
func NewGetIngestUnprocessableEntity() *GetIngestUnprocessableEntity {
	return &GetIngestUnprocessableEntity{}
}

/* GetIngestUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetIngestUnprocessableEntity struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Error
}

func (o *GetIngestUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /ingests/{ingestIdPath}][%d] getIngestUnprocessableEntity  %+v", 422, o.Payload)
}
func (o *GetIngestUnprocessableEntity) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetIngestUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetIngestInternalServerError creates a GetIngestInternalServerError with default headers values
func NewGetIngestInternalServerError() *GetIngestInternalServerError {
	return &GetIngestInternalServerError{}
}

/* GetIngestInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type GetIngestInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetIngestInternalServerError) Error() string {
	return fmt.Sprintf("[GET /ingests/{ingestIdPath}][%d] getIngestInternalServerError  %+v", 500, o.Payload)
}
func (o *GetIngestInternalServerError) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetIngestInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
