// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package ingest

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/devops/devops_models"
)

// GetIngestsObservableReader is a Reader for the GetIngestsObservable structure.
type GetIngestsObservableReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetIngestsObservableReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetIngestsObservableOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetIngestsObservableUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetIngestsObservableForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetIngestsObservableNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetIngestsObservableUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetIngestsObservableInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetIngestsObservableOK creates a GetIngestsObservableOK with default headers values
func NewGetIngestsObservableOK() *GetIngestsObservableOK {
	return &GetIngestsObservableOK{}
}

/* GetIngestsObservableOK describes a response with status code 200, with default header values.

Single Ingest record response
*/
type GetIngestsObservableOK struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload []*devops_models.Ingest
}

func (o *GetIngestsObservableOK) Error() string {
	return fmt.Sprintf("[GET /ingests/observable][%d] getIngestsObservableOK  %+v", 200, o.Payload)
}
func (o *GetIngestsObservableOK) GetPayload() []*devops_models.Ingest {
	return o.Payload
}

func (o *GetIngestsObservableOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetIngestsObservableUnauthorized creates a GetIngestsObservableUnauthorized with default headers values
func NewGetIngestsObservableUnauthorized() *GetIngestsObservableUnauthorized {
	return &GetIngestsObservableUnauthorized{}
}

/* GetIngestsObservableUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type GetIngestsObservableUnauthorized struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Error
}

func (o *GetIngestsObservableUnauthorized) Error() string {
	return fmt.Sprintf("[GET /ingests/observable][%d] getIngestsObservableUnauthorized  %+v", 401, o.Payload)
}
func (o *GetIngestsObservableUnauthorized) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetIngestsObservableUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetIngestsObservableForbidden creates a GetIngestsObservableForbidden with default headers values
func NewGetIngestsObservableForbidden() *GetIngestsObservableForbidden {
	return &GetIngestsObservableForbidden{}
}

/* GetIngestsObservableForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type GetIngestsObservableForbidden struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetIngestsObservableForbidden) Error() string {
	return fmt.Sprintf("[GET /ingests/observable][%d] getIngestsObservableForbidden  %+v", 403, o.Payload)
}
func (o *GetIngestsObservableForbidden) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetIngestsObservableForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetIngestsObservableNotFound creates a GetIngestsObservableNotFound with default headers values
func NewGetIngestsObservableNotFound() *GetIngestsObservableNotFound {
	return &GetIngestsObservableNotFound{}
}

/* GetIngestsObservableNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type GetIngestsObservableNotFound struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetIngestsObservableNotFound) Error() string {
	return fmt.Sprintf("[GET /ingests/observable][%d] getIngestsObservableNotFound  %+v", 404, o.Payload)
}
func (o *GetIngestsObservableNotFound) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetIngestsObservableNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetIngestsObservableUnprocessableEntity creates a GetIngestsObservableUnprocessableEntity with default headers values
func NewGetIngestsObservableUnprocessableEntity() *GetIngestsObservableUnprocessableEntity {
	return &GetIngestsObservableUnprocessableEntity{}
}

/* GetIngestsObservableUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetIngestsObservableUnprocessableEntity struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Error
}

func (o *GetIngestsObservableUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /ingests/observable][%d] getIngestsObservableUnprocessableEntity  %+v", 422, o.Payload)
}
func (o *GetIngestsObservableUnprocessableEntity) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetIngestsObservableUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetIngestsObservableInternalServerError creates a GetIngestsObservableInternalServerError with default headers values
func NewGetIngestsObservableInternalServerError() *GetIngestsObservableInternalServerError {
	return &GetIngestsObservableInternalServerError{}
}

/* GetIngestsObservableInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type GetIngestsObservableInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetIngestsObservableInternalServerError) Error() string {
	return fmt.Sprintf("[GET /ingests/observable][%d] getIngestsObservableInternalServerError  %+v", 500, o.Payload)
}
func (o *GetIngestsObservableInternalServerError) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetIngestsObservableInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
