// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package job

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/devops/devops_models"
)

// GetJobsObservableReader is a Reader for the GetJobsObservable structure.
type GetJobsObservableReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetJobsObservableReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetJobsObservableOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetJobsObservableUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetJobsObservableForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetJobsObservableNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetJobsObservableUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetJobsObservableInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetJobsObservableOK creates a GetJobsObservableOK with default headers values
func NewGetJobsObservableOK() *GetJobsObservableOK {
	return &GetJobsObservableOK{}
}

/* GetJobsObservableOK describes a response with status code 200, with default header values.

Single Job record response
*/
type GetJobsObservableOK struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload []*devops_models.Job
}

func (o *GetJobsObservableOK) Error() string {
	return fmt.Sprintf("[GET /jobs/observable][%d] getJobsObservableOK  %+v", 200, o.Payload)
}
func (o *GetJobsObservableOK) GetPayload() []*devops_models.Job {
	return o.Payload
}

func (o *GetJobsObservableOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetJobsObservableUnauthorized creates a GetJobsObservableUnauthorized with default headers values
func NewGetJobsObservableUnauthorized() *GetJobsObservableUnauthorized {
	return &GetJobsObservableUnauthorized{}
}

/* GetJobsObservableUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type GetJobsObservableUnauthorized struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Error
}

func (o *GetJobsObservableUnauthorized) Error() string {
	return fmt.Sprintf("[GET /jobs/observable][%d] getJobsObservableUnauthorized  %+v", 401, o.Payload)
}
func (o *GetJobsObservableUnauthorized) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetJobsObservableUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetJobsObservableForbidden creates a GetJobsObservableForbidden with default headers values
func NewGetJobsObservableForbidden() *GetJobsObservableForbidden {
	return &GetJobsObservableForbidden{}
}

/* GetJobsObservableForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type GetJobsObservableForbidden struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetJobsObservableForbidden) Error() string {
	return fmt.Sprintf("[GET /jobs/observable][%d] getJobsObservableForbidden  %+v", 403, o.Payload)
}
func (o *GetJobsObservableForbidden) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetJobsObservableForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetJobsObservableNotFound creates a GetJobsObservableNotFound with default headers values
func NewGetJobsObservableNotFound() *GetJobsObservableNotFound {
	return &GetJobsObservableNotFound{}
}

/* GetJobsObservableNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type GetJobsObservableNotFound struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetJobsObservableNotFound) Error() string {
	return fmt.Sprintf("[GET /jobs/observable][%d] getJobsObservableNotFound  %+v", 404, o.Payload)
}
func (o *GetJobsObservableNotFound) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetJobsObservableNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetJobsObservableUnprocessableEntity creates a GetJobsObservableUnprocessableEntity with default headers values
func NewGetJobsObservableUnprocessableEntity() *GetJobsObservableUnprocessableEntity {
	return &GetJobsObservableUnprocessableEntity{}
}

/* GetJobsObservableUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetJobsObservableUnprocessableEntity struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Error
}

func (o *GetJobsObservableUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /jobs/observable][%d] getJobsObservableUnprocessableEntity  %+v", 422, o.Payload)
}
func (o *GetJobsObservableUnprocessableEntity) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetJobsObservableUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetJobsObservableInternalServerError creates a GetJobsObservableInternalServerError with default headers values
func NewGetJobsObservableInternalServerError() *GetJobsObservableInternalServerError {
	return &GetJobsObservableInternalServerError{}
}

/* GetJobsObservableInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type GetJobsObservableInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetJobsObservableInternalServerError) Error() string {
	return fmt.Sprintf("[GET /jobs/observable][%d] getJobsObservableInternalServerError  %+v", 500, o.Payload)
}
func (o *GetJobsObservableInternalServerError) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetJobsObservableInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
