// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package job

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/devops/devops_models"
)

// PostJobsReader is a Reader for the PostJobs structure.
type PostJobsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostJobsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostJobsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostJobsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostJobsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostJobsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPostJobsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostJobsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewPostJobsOK creates a PostJobsOK with default headers values
func NewPostJobsOK() *PostJobsOK {
	return &PostJobsOK{}
}

/* PostJobsOK describes a response with status code 200, with default header values.

Taxnexus Response with Job objects
*/
type PostJobsOK struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.JobResponse
}

func (o *PostJobsOK) Error() string {
	return fmt.Sprintf("[POST /jobs][%d] postJobsOK  %+v", 200, o.Payload)
}
func (o *PostJobsOK) GetPayload() *devops_models.JobResponse {
	return o.Payload
}

func (o *PostJobsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.JobResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostJobsUnauthorized creates a PostJobsUnauthorized with default headers values
func NewPostJobsUnauthorized() *PostJobsUnauthorized {
	return &PostJobsUnauthorized{}
}

/* PostJobsUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type PostJobsUnauthorized struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Error
}

func (o *PostJobsUnauthorized) Error() string {
	return fmt.Sprintf("[POST /jobs][%d] postJobsUnauthorized  %+v", 401, o.Payload)
}
func (o *PostJobsUnauthorized) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PostJobsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostJobsForbidden creates a PostJobsForbidden with default headers values
func NewPostJobsForbidden() *PostJobsForbidden {
	return &PostJobsForbidden{}
}

/* PostJobsForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type PostJobsForbidden struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *PostJobsForbidden) Error() string {
	return fmt.Sprintf("[POST /jobs][%d] postJobsForbidden  %+v", 403, o.Payload)
}
func (o *PostJobsForbidden) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PostJobsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostJobsNotFound creates a PostJobsNotFound with default headers values
func NewPostJobsNotFound() *PostJobsNotFound {
	return &PostJobsNotFound{}
}

/* PostJobsNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type PostJobsNotFound struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *PostJobsNotFound) Error() string {
	return fmt.Sprintf("[POST /jobs][%d] postJobsNotFound  %+v", 404, o.Payload)
}
func (o *PostJobsNotFound) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PostJobsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostJobsUnprocessableEntity creates a PostJobsUnprocessableEntity with default headers values
func NewPostJobsUnprocessableEntity() *PostJobsUnprocessableEntity {
	return &PostJobsUnprocessableEntity{}
}

/* PostJobsUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PostJobsUnprocessableEntity struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Error
}

func (o *PostJobsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[POST /jobs][%d] postJobsUnprocessableEntity  %+v", 422, o.Payload)
}
func (o *PostJobsUnprocessableEntity) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PostJobsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostJobsInternalServerError creates a PostJobsInternalServerError with default headers values
func NewPostJobsInternalServerError() *PostJobsInternalServerError {
	return &PostJobsInternalServerError{}
}

/* PostJobsInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type PostJobsInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *PostJobsInternalServerError) Error() string {
	return fmt.Sprintf("[POST /jobs][%d] postJobsInternalServerError  %+v", 500, o.Payload)
}
func (o *PostJobsInternalServerError) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PostJobsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
