// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package accounts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/sfgate/sfgate_models"
)

// PostAccountsReader is a Reader for the PostAccounts structure.
type PostAccountsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostAccountsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostAccountsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostAccountsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostAccountsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostAccountsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostAccountsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewPostAccountsOK creates a PostAccountsOK with default headers values
func NewPostAccountsOK() *PostAccountsOK {
	return &PostAccountsOK{}
}

/* PostAccountsOK describes a response with status code 200, with default header values.

Taxnexus Response with Account objects
*/
type PostAccountsOK struct {
	Payload *sfgate_models.AccountResponse
}

func (o *PostAccountsOK) Error() string {
	return fmt.Sprintf("[POST /accounts][%d] postAccountsOK  %+v", 200, o.Payload)
}
func (o *PostAccountsOK) GetPayload() *sfgate_models.AccountResponse {
	return o.Payload
}

func (o *PostAccountsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.AccountResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostAccountsUnauthorized creates a PostAccountsUnauthorized with default headers values
func NewPostAccountsUnauthorized() *PostAccountsUnauthorized {
	return &PostAccountsUnauthorized{}
}

/* PostAccountsUnauthorized describes a response with status code 401, with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PostAccountsUnauthorized struct {
	Payload *sfgate_models.Error
}

func (o *PostAccountsUnauthorized) Error() string {
	return fmt.Sprintf("[POST /accounts][%d] postAccountsUnauthorized  %+v", 401, o.Payload)
}
func (o *PostAccountsUnauthorized) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *PostAccountsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostAccountsForbidden creates a PostAccountsForbidden with default headers values
func NewPostAccountsForbidden() *PostAccountsForbidden {
	return &PostAccountsForbidden{}
}

/* PostAccountsForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type PostAccountsForbidden struct {
	Payload *sfgate_models.Error
}

func (o *PostAccountsForbidden) Error() string {
	return fmt.Sprintf("[POST /accounts][%d] postAccountsForbidden  %+v", 403, o.Payload)
}
func (o *PostAccountsForbidden) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *PostAccountsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostAccountsNotFound creates a PostAccountsNotFound with default headers values
func NewPostAccountsNotFound() *PostAccountsNotFound {
	return &PostAccountsNotFound{}
}

/* PostAccountsNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type PostAccountsNotFound struct {
	Payload *sfgate_models.Error
}

func (o *PostAccountsNotFound) Error() string {
	return fmt.Sprintf("[POST /accounts][%d] postAccountsNotFound  %+v", 404, o.Payload)
}
func (o *PostAccountsNotFound) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *PostAccountsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostAccountsInternalServerError creates a PostAccountsInternalServerError with default headers values
func NewPostAccountsInternalServerError() *PostAccountsInternalServerError {
	return &PostAccountsInternalServerError{}
}

/* PostAccountsInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type PostAccountsInternalServerError struct {
	Payload *sfgate_models.Error
}

func (o *PostAccountsInternalServerError) Error() string {
	return fmt.Sprintf("[POST /accounts][%d] postAccountsInternalServerError  %+v", 500, o.Payload)
}
func (o *PostAccountsInternalServerError) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *PostAccountsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
