// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package accounts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/sfgate/sfgate_models"
)

// PutAccountReader is a Reader for the PutAccount structure.
type PutAccountReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PutAccountReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPutAccountOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPutAccountUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPutAccountForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPutAccountNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPutAccountInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewPutAccountOK creates a PutAccountOK with default headers values
func NewPutAccountOK() *PutAccountOK {
	return &PutAccountOK{}
}

/* PutAccountOK describes a response with status code 200, with default header values.

Taxnexus Response with Account objects
*/
type PutAccountOK struct {
	Payload *sfgate_models.AccountResponse
}

func (o *PutAccountOK) Error() string {
	return fmt.Sprintf("[PUT /accounts][%d] putAccountOK  %+v", 200, o.Payload)
}
func (o *PutAccountOK) GetPayload() *sfgate_models.AccountResponse {
	return o.Payload
}

func (o *PutAccountOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.AccountResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutAccountUnauthorized creates a PutAccountUnauthorized with default headers values
func NewPutAccountUnauthorized() *PutAccountUnauthorized {
	return &PutAccountUnauthorized{}
}

/* PutAccountUnauthorized describes a response with status code 401, with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PutAccountUnauthorized struct {
	Payload *sfgate_models.Error
}

func (o *PutAccountUnauthorized) Error() string {
	return fmt.Sprintf("[PUT /accounts][%d] putAccountUnauthorized  %+v", 401, o.Payload)
}
func (o *PutAccountUnauthorized) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *PutAccountUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutAccountForbidden creates a PutAccountForbidden with default headers values
func NewPutAccountForbidden() *PutAccountForbidden {
	return &PutAccountForbidden{}
}

/* PutAccountForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type PutAccountForbidden struct {
	Payload *sfgate_models.Error
}

func (o *PutAccountForbidden) Error() string {
	return fmt.Sprintf("[PUT /accounts][%d] putAccountForbidden  %+v", 403, o.Payload)
}
func (o *PutAccountForbidden) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *PutAccountForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutAccountNotFound creates a PutAccountNotFound with default headers values
func NewPutAccountNotFound() *PutAccountNotFound {
	return &PutAccountNotFound{}
}

/* PutAccountNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type PutAccountNotFound struct {
	Payload *sfgate_models.Error
}

func (o *PutAccountNotFound) Error() string {
	return fmt.Sprintf("[PUT /accounts][%d] putAccountNotFound  %+v", 404, o.Payload)
}
func (o *PutAccountNotFound) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *PutAccountNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutAccountInternalServerError creates a PutAccountInternalServerError with default headers values
func NewPutAccountInternalServerError() *PutAccountInternalServerError {
	return &PutAccountInternalServerError{}
}

/* PutAccountInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type PutAccountInternalServerError struct {
	Payload *sfgate_models.Error
}

func (o *PutAccountInternalServerError) Error() string {
	return fmt.Sprintf("[PUT /accounts][%d] putAccountInternalServerError  %+v", 500, o.Payload)
}
func (o *PutAccountInternalServerError) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *PutAccountInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
