// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package companies

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetCompaniesParams creates a new GetCompaniesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetCompaniesParams() *GetCompaniesParams {
	return &GetCompaniesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetCompaniesParamsWithTimeout creates a new GetCompaniesParams object
// with the ability to set a timeout on a request.
func NewGetCompaniesParamsWithTimeout(timeout time.Duration) *GetCompaniesParams {
	return &GetCompaniesParams{
		timeout: timeout,
	}
}

// NewGetCompaniesParamsWithContext creates a new GetCompaniesParams object
// with the ability to set a context for a request.
func NewGetCompaniesParamsWithContext(ctx context.Context) *GetCompaniesParams {
	return &GetCompaniesParams{
		Context: ctx,
	}
}

// NewGetCompaniesParamsWithHTTPClient creates a new GetCompaniesParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetCompaniesParamsWithHTTPClient(client *http.Client) *GetCompaniesParams {
	return &GetCompaniesParams{
		HTTPClient: client,
	}
}

/* GetCompaniesParams contains all the parameters to send to the API endpoint
   for the get companies operation.

   Typically these are written to a http.Request.
*/
type GetCompaniesParams struct {

	/* CompanyID.

	   Taxnexus Id of the Company to be retrieved
	*/
	CompanyID *string

	/* Limit.

	   How many objects to return at one time

	   Format: int64
	*/
	Limit *int64

	/* Offset.

	   How many objects to skip? (default 0)

	   Format: int64
	*/
	Offset *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get companies params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetCompaniesParams) WithDefaults() *GetCompaniesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get companies params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetCompaniesParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get companies params
func (o *GetCompaniesParams) WithTimeout(timeout time.Duration) *GetCompaniesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get companies params
func (o *GetCompaniesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get companies params
func (o *GetCompaniesParams) WithContext(ctx context.Context) *GetCompaniesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get companies params
func (o *GetCompaniesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get companies params
func (o *GetCompaniesParams) WithHTTPClient(client *http.Client) *GetCompaniesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get companies params
func (o *GetCompaniesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithCompanyID adds the companyID to the get companies params
func (o *GetCompaniesParams) WithCompanyID(companyID *string) *GetCompaniesParams {
	o.SetCompanyID(companyID)
	return o
}

// SetCompanyID adds the companyId to the get companies params
func (o *GetCompaniesParams) SetCompanyID(companyID *string) {
	o.CompanyID = companyID
}

// WithLimit adds the limit to the get companies params
func (o *GetCompaniesParams) WithLimit(limit *int64) *GetCompaniesParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get companies params
func (o *GetCompaniesParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get companies params
func (o *GetCompaniesParams) WithOffset(offset *int64) *GetCompaniesParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get companies params
func (o *GetCompaniesParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WriteToRequest writes these params to a swagger request
func (o *GetCompaniesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.CompanyID != nil {

		// query param companyId
		var qrCompanyID string

		if o.CompanyID != nil {
			qrCompanyID = *o.CompanyID
		}
		qCompanyID := qrCompanyID
		if qCompanyID != "" {

			if err := r.SetQueryParam("companyId", qCompanyID); err != nil {
				return err
			}
		}
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
