// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package sfgate_client

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"github.com/go-openapi/runtime"
	httptransport "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/sfgate/sfgate_client/accounts"
	"code.tnxs.net/vernonkeenan/lib/api/sfgate/sfgate_client/companies"
	"code.tnxs.net/vernonkeenan/lib/api/sfgate/sfgate_client/contacts"
	"code.tnxs.net/vernonkeenan/lib/api/sfgate/sfgate_client/notebooks"
	"code.tnxs.net/vernonkeenan/lib/api/sfgate/sfgate_client/products"
	"code.tnxs.net/vernonkeenan/lib/api/sfgate/sfgate_client/roles"
	"code.tnxs.net/vernonkeenan/lib/api/sfgate/sfgate_client/templates"
	"code.tnxs.net/vernonkeenan/lib/api/sfgate/sfgate_client/tenants"
	"code.tnxs.net/vernonkeenan/lib/api/sfgate/sfgate_client/users"
)

// Default sfgate HTTP client.
var Default = NewHTTPClient(nil)

const (
	// DefaultHost is the default Host
	// found in Meta (info) section of spec file
	DefaultHost string = "sf-gate.fabric.tnxs.net:8080"
	// DefaultBasePath is the default BasePath
	// found in Meta (info) section of spec file
	DefaultBasePath string = "/v1"
)

// DefaultSchemes are the default schemes found in Meta (info) section of spec file
var DefaultSchemes = []string{"http"}

// NewHTTPClient creates a new sfgate HTTP client.
func NewHTTPClient(formats strfmt.Registry) *Sfgate {
	return NewHTTPClientWithConfig(formats, nil)
}

// NewHTTPClientWithConfig creates a new sfgate HTTP client,
// using a customizable transport config.
func NewHTTPClientWithConfig(formats strfmt.Registry, cfg *TransportConfig) *Sfgate {
	// ensure nullable parameters have default
	if cfg == nil {
		cfg = DefaultTransportConfig()
	}

	// create transport and client
	transport := httptransport.New(cfg.Host, cfg.BasePath, cfg.Schemes)
	return New(transport, formats)
}

// New creates a new sfgate client
func New(transport runtime.ClientTransport, formats strfmt.Registry) *Sfgate {
	// ensure nullable parameters have default
	if formats == nil {
		formats = strfmt.Default
	}

	cli := new(Sfgate)
	cli.Transport = transport
	cli.Accounts = accounts.New(transport, formats)
	cli.Companies = companies.New(transport, formats)
	cli.Contacts = contacts.New(transport, formats)
	cli.Notebooks = notebooks.New(transport, formats)
	cli.Products = products.New(transport, formats)
	cli.Roles = roles.New(transport, formats)
	cli.Templates = templates.New(transport, formats)
	cli.Tenants = tenants.New(transport, formats)
	cli.Users = users.New(transport, formats)
	return cli
}

// DefaultTransportConfig creates a TransportConfig with the
// default settings taken from the meta section of the spec file.
func DefaultTransportConfig() *TransportConfig {
	return &TransportConfig{
		Host:     DefaultHost,
		BasePath: DefaultBasePath,
		Schemes:  DefaultSchemes,
	}
}

// TransportConfig contains the transport related info,
// found in the meta section of the spec file.
type TransportConfig struct {
	Host     string
	BasePath string
	Schemes  []string
}

// WithHost overrides the default host,
// provided by the meta section of the spec file.
func (cfg *TransportConfig) WithHost(host string) *TransportConfig {
	cfg.Host = host
	return cfg
}

// WithBasePath overrides the default basePath,
// provided by the meta section of the spec file.
func (cfg *TransportConfig) WithBasePath(basePath string) *TransportConfig {
	cfg.BasePath = basePath
	return cfg
}

// WithSchemes overrides the default schemes,
// provided by the meta section of the spec file.
func (cfg *TransportConfig) WithSchemes(schemes []string) *TransportConfig {
	cfg.Schemes = schemes
	return cfg
}

// Sfgate is a client for sfgate
type Sfgate struct {
	Accounts accounts.ClientService

	Companies companies.ClientService

	Contacts contacts.ClientService

	Notebooks notebooks.ClientService

	Products products.ClientService

	Roles roles.ClientService

	Templates templates.ClientService

	Tenants tenants.ClientService

	Users users.ClientService

	Transport runtime.ClientTransport
}

// SetTransport changes the transport on the client and all its subresources
func (c *Sfgate) SetTransport(transport runtime.ClientTransport) {
	c.Transport = transport
	c.Accounts.SetTransport(transport)
	c.Companies.SetTransport(transport)
	c.Contacts.SetTransport(transport)
	c.Notebooks.SetTransport(transport)
	c.Products.SetTransport(transport)
	c.Roles.SetTransport(transport)
	c.Templates.SetTransport(transport)
	c.Tenants.SetTransport(transport)
	c.Users.SetTransport(transport)
}
