// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package cors

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new cors API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for cors API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientOption is the option for Client methods
type ClientOption func(*runtime.ClientOperation)

// ClientService is the interface for Client methods
type ClientService interface {
	AppLogOptions(params *AppLogOptionsParams, opts ...ClientOption) (*AppLogOptionsOK, error)

	EmailMessageOptions(params *EmailMessageOptionsParams, opts ...ClientOption) (*EmailMessageOptionsOK, error)

	OutgoingEmailMessageOptions(params *OutgoingEmailMessageOptionsParams, opts ...ClientOption) (*OutgoingEmailMessageOptionsOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  AppLogOptions CORS support
*/
func (a *Client) AppLogOptions(params *AppLogOptionsParams, opts ...ClientOption) (*AppLogOptionsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewAppLogOptionsParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "appLogOptions",
		Method:             "OPTIONS",
		PathPattern:        "/applogs",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &AppLogOptionsReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*AppLogOptionsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for appLogOptions: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  EmailMessageOptions CORS support
*/
func (a *Client) EmailMessageOptions(params *EmailMessageOptionsParams, opts ...ClientOption) (*EmailMessageOptionsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewEmailMessageOptionsParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "emailMessageOptions",
		Method:             "OPTIONS",
		PathPattern:        "/emailmessages",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &EmailMessageOptionsReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*EmailMessageOptionsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for emailMessageOptions: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  OutgoingEmailMessageOptions CORS support
*/
func (a *Client) OutgoingEmailMessageOptions(params *OutgoingEmailMessageOptionsParams, opts ...ClientOption) (*OutgoingEmailMessageOptionsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewOutgoingEmailMessageOptionsParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "outgoingEmailMessageOptions",
		Method:             "OPTIONS",
		PathPattern:        "/outgoingemailmessages",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &OutgoingEmailMessageOptionsReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*OutgoingEmailMessageOptionsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for outgoingEmailMessageOptions: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
